#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>

int contador(char str[])
{
    int i, count = 1;

    for(i = 0; str[i] != '\0'; i++)
    {
        count++;
    }

    return count;
}

char *barra_barra(char str[])
{
    int k, i;
    for (k = strlen(str); k >= 0; k--)
    {
        if(str[k] == '\\')
        {
            for(i = strlen(str); i>= k; i--)
            {
                str[i + 1] = str[i];
            }
        }

    }

    return str;
}

char *aspa_aspa(char str[])
{
    int k, i;
    str[strlen(str) + 1] = '"';

    for (k = strlen(str); k >= 0; k--)
    {
        str[k + 1] = str[k];

    }

    str[0] = '"';

    return str;
}

struct mp3_dados
{
    char tag_v1[4];
    char tag_v2[7];
    char taxa_tag[15];
    char titulo[31];
    char artista[31];
    char album[31];
    char ano[5];
    char comentario[31];
    char genero[50];
};

void dados(FILE *entra)
{
    FILE *musica, *tempora;
    DIR *local;
    struct dirent *folder;
    char *enderec, *buscado, *temporario;
    struct mp3_dados info;

    if((entra = fopen("saida.txt", "r")) == NULL)
    {
        exit(1);
    }

    tempora = fopen("mp3.txt","wb");



    while(!feof(entra))
    {

        enderec = (char*)malloc(200*sizeof(char));
        buscado = (char*)malloc(50*sizeof(char));

        fgets(enderec, 100, entra);
        fgets(buscado, 50, entra);

        printf("%s", enderec);
        printf("%s", buscado);

        barra_barra(enderec);

        aspa_aspa(enderec);

        printf("%s", enderec);

        temporario = (char*)malloc(strlen(enderec)*sizeof(char));
        //enderec = (char*)realloc(enderec, contador(enderec)*sizeof(char));
        strcpy(temporario, enderec);

        printf("%s", temporario);

        local = opendir(temporario);

        printf("%s",local);

        if((local = opendir(temporario)) == NULL)
        {
            exit (1);
        }


        do
        {

            folder = readdir(local);

        }while (strcmp(buscado, folder->d_name));



        strcat(enderec, buscado);
        //strcat(enderec, ".mp3");

        musica = fopen(enderec, "rb");

        fprintf(tempora,"\n----------------------------\n");
        fprintf(tempora, "ID3 TAG versao 2:\n");
        fread(info.tag_v2, 5, sizeof(char), musica);
        fwrite(info.tag_v2, 3, sizeof(char), tempora);
        fprintf(tempora,"\n");

        fread(info.taxa_tag, 14, sizeof(char), musica);
        fwrite(info.taxa_tag, 14, sizeof(char), tempora);
        fprintf(tempora,"\n");
        //fread(teste, 1999, sizeof(char), in);
        //fwrite(teste, 1999, sizeof(char), out);
        //fprintf(out,"\n");


        //fprintf(out,"\n-------------------\n");

        fprintf(tempora ,"ID3 TAG versao 1:\n");
        fseek(musica, -128, SEEK_END);
        fread(info.tag_v1, 3, sizeof(char), musica);
        fwrite(info.tag_v1, 3, sizeof(char), tempora);
        fprintf(tempora,"\n");
        fread(info.titulo, 30, sizeof(char), musica);
        fwrite(info.titulo, 30, sizeof(char), tempora);
        fprintf(tempora,"\n");
        fread(info.artista, 30, sizeof(char), musica);
        fwrite(info.artista, 30, sizeof(char), tempora);
        fprintf(tempora,"\n");
        fread(info.album, 30, sizeof(char), musica);
        fwrite(info.album, 30, sizeof(char), tempora);
        fprintf(tempora,"\n");
        fread(info.ano, 4, sizeof(char), musica);
        fwrite(info.ano, 4, sizeof(char), tempora);
        fprintf(tempora,"\n");
        fread(info.comentario, 30, sizeof(char), musica);
        fwrite(info.comentario, 30, sizeof(char), tempora);
        fprintf(tempora,"\n");
        fread(info.genero, 1, sizeof(char), musica);
        fwrite(info.genero, 1, sizeof(char), tempora);
        fprintf(tempora,"\n\n\n");


        free(enderec);
        free(buscado);

    }

    fclose(musica);
    fclose(entra);
    fclose(tempora);

}
